CBL NODYNAM,LIB,OBJECT,RENT,RES,APOST                                   REA00010
      *                                                               * REA00020
      * ------------------------------------------------------------- * REA00030
       IDENTIFICATION DIVISION.                                         REA00040
      * ------------------------------------------------------------- * REA00050
       PROGRAM-ID. READPCF.                                             REA00060
      *REMARKS                                                          REA00070
      ***************************************************************** REA00080
      *  Module Name      : READPCF                                   * REA00090
      *                                                               * REA00100
      *  Environment      : MVS Batch; COBOL II                       * REA00110
      *                                                               * REA00120
      *  Description      : Test program to print EVENT messages from * REA00130
      *                     specified admin queue.                    * REA00140
      *                                                               * REA00150
      *  Limitations      : Channel events ONLY tested.               * REA00160
      *                     Based on another program, some            * REA00170
      *                     declarations may be unused.               * REA00180
      *                                                               * REA00190
      *  Function         : This program prints a report showing all  * REA00200
      *                     fields of the EVENT messages from a       * REA00210
      *                     specified queue and queue manager         * REA00220
      *                                                               * REA00230
      *  Requires         : MQ copybooks                              * REA00240
      *                                                               * REA00250
      * ************************************************************* * REA00260
      * ------------------------------------------------------------- * REA00270
       ENVIRONMENT DIVISION.                                            REA00280
      * ------------------------------------------------------------- * REA00290
       INPUT-OUTPUT SECTION.                                            REA00300
       FILE-CONTROL.                                                    REA00310
      * ------------------------------------------------------------- * REA00320
       DATA DIVISION.                                                   REA00330
      * ------------------------------------------------------------- * REA00340
       FILE SECTION.                                                    REA00350
      * ------------------------------------------------------------- * REA00360
       WORKING-STORAGE SECTION.                                         REA00370
      * ------------------------------------------------------------- * REA00380
      *                                                                 REA00390
      *    W00 - General work fields                                    REA00400
      *                                                                 REA00410
       01  W00-MESSAGE-COUNT           PIC s9(9) BINARY  VALUE ZERO.    REA00420
       01  W00-DATE.                                                    REA00430
           05  W00-YY                  PIC 99.                          REA00440
           05  W00-MM                  PIC 99.                          REA00450
           05  W00-DD                  PIC 99.                          REA00460
       01  W00-PRINT-DATA              PIC X(132).                      REA00470
       01  W00-RETURN-CODE             PIC S9(04) BINARY  VALUE ZERO.   REA00480
      *                                                                 REA00490
      *    W01 - Lines of the print report                              REA00500
      *                                                                 REA00510
       01  W01-HEADER-1.                                                REA00520
           05  FILLER                  PIC X(10) VALUE SPACES.          REA00530
           05  W01-MM                  PIC 99.                          REA00540
           05  FILLER                  PIC X     VALUE '/'.             REA00550
           05  W01-DD                  PIC 99.                          REA00560
           05  FILLER                  PIC X     VALUE '/'.             REA00570
           05  W01-YY                  PIC 99.                          REA00580
           05  FILLER                  PIC X(8) VALUE SPACES.           REA00590
           05  FILLER                  PIC X(20) VALUE                  REA00600
                                                 'EVENT MESSAGE REPORT'.REA00610
           05  FILLER                  PIC X(37) VALUE SPACES.          REA00620
           05  FILLER                  PIC X(09) VALUE SPACES.          REA00630
           05  FILLER                  PIC X(10) VALUE SPACES.          REA00640
       01  W01-HEADER-2.                                                REA00650
           05  FILLER                  PIC X(5) VALUE SPACES.           REA00660
           05  FILLER                  PIC X(29) VALUE                  REA00670
                                       '        QUEUE MANAGER NAME : '. REA00680
           05  W01-MQM-NAME            PIC X(48) VALUE SPACES.          REA00690
           05  FILLER                  PIC X(30) VALUE SPACES.          REA00700
       01  W01-HEADER-3.                                                REA00710
           05  FILLER                  PIC X(17) VALUE SPACES.          REA00720
           05  FILLER                  PIC X(17) VALUE                  REA00730
                                                    '    QUEUE NAME : '.REA00740
           05  W01-QUEUE-NAME          PIC X(48) VALUE SPACES.          REA00750
           05  FILLER                  PIC X(30) VALUE SPACES.          REA00760
       01  W01-HEADER-4.                                                REA00770
           05  FILLER                  PIC X(16)  VALUE SPACES.         REA00780
           05  FILLER                  PIC X(116) VALUE SPACES.         REA00790
      *                                                                 REA00800
      *    W02 - Data fields derived from the PARM field                REA00810
      *                                                                 REA00820
       01  W02-MQM                     PIC X(48) VALUE SPACES.          REA00830
       01  W02-OBJECT                  PIC X(48) VALUE SPACES.          REA00840
      *                                                                 REA00850
      *    W03 - MQM API fields                                         REA00860
      *                                                                 REA00870
       01  W03-BUFFER-LENGTH           PIC S9(9) BINARY  VALUE 4096.    REA00880
       01  W03-HCONN                   PIC S9(9) BINARY.                REA00890
       01  W03-OPTIONS                 PIC S9(9) BINARY.                REA00900
       01  W03-HOBJ                    PIC S9(9) BINARY.                REA00910
       01  W03-DATA-LENGTH             PIC S9(9) BINARY.                REA00920
       01  W03-COMPCODE                PIC S9(9) BINARY.                REA00930
       01  W03-REASON                  PIC S9(9) BINARY.                REA00940
       01  W03-MESSAGE-DATA            PIC X(4094) VALUE SPACES.        REA00950
      *                                                                 REA00960
      *    W04 - Error and information messages                         REA00970
      *                                                                 REA00980
       01  W04-MESSAGE-0.                                               REA00990
           05  FILLER              PIC X(28) VALUE SPACES.              REA01000
           05  FILLER              PIC X(35) VALUE                      REA01010
                                  '********** END OF REPORT **********'.REA01020
           05  FILLER              PIC X(49) VALUE SPACES.              REA01030
       01  W04-MESSAGE-1.                                               REA01040
           05  FILLER              PIC X(1)  VALUE SPACES.              REA01050
           05  FILLER              PIC X(122) VALUE                     REA01060
              '********** NO DATA PASSED TO PROGRAM. PROGRAM REQUIRES A REA01070
      -       'QUEUE MANAGER NAME AND A QUEUE NAME. **********'.        REA01080
       01  W04-MESSAGE-2.                                               REA01090
           05  FILLER              PIC X(5)  VALUE SPACES.              REA01100
           05  FILLER              PIC X(107) VALUE                     REA01110
              '********** NO QUEUE MANAGER NAME PASSED TO PROGRAM - DEFAREA01120
      -       'ULT USED *****'.                                         REA01130
       01  W04-MESSAGE-3.                                               REA01140
           05  FILLER              PIC X(18) VALUE SPACES.              REA01150
           05  FILLER              PIC X(94) VALUE                      REA01160
              '********** NO QUEUE NAME PASSED TO PROGRAM. **********'. REA01170
       01  W04-MESSAGE-4.                                               REA01180
           05  FILLER              PIC X(1) VALUE SPACES.               REA01190
           05  FILLER              PIC X(32) VALUE                      REA01200
                   '********** AN ERROR OCCURRED IN '.                  REA01210
           05  W04-MSG4-TYPE       PIC X(10).                           REA01220
           05  FILLER              PIC X(20) VALUE                      REA01230
                   '. COMPLETION CODE = '.                              REA01240
           05  W04-MSG4-COMPCODE   PIC Z(8)9.                           REA01250
           05  FILLER              PIC X(15) VALUE ' REASON CODE ='.    REA01260
           05  W04-MSG4-REASON     PIC Z(8)9.                           REA01270
           05  FILLER              PIC X(24) VALUE ' **********'.       REA01280
      *                                                                 REA01290
      *    The following copy files define API control blocks.          REA01300
      *                                                                 REA01310
       01  W05-MQM-OBJECT-DESCRIPTOR.                                   REA01320
           COPY CMQODV.                                                 REA01330
       01  W05-MQM-MESSAGE-DESCRIPTOR.                                  REA01340
           COPY CMQMDV.                                                 REA01350
       01  W05-MQM-GET-MESSAGE-OPTIONS.                                 REA01360
           COPY CMQGMOV.                                                REA01370
      *                                                                 REA01380
      *    Copy file of constants (for filling in the control blocks)   REA01390
      *    and return codes (for testing the result of a call)          REA01400
      *                                                                 REA01410
       01  W05-MQM-CONSTANTS.                                           REA01420
           COPY CMQV.                                                   REA01430
      *                                                                 REA01440
      *    W06 - Return values                                          REA01450
      *                                                                 REA01460
       01  W06-CSQ4-OK             PIC S9(4) VALUE 0.                   REA01470
       01  W06-CSQ4-WARNING        PIC S9(4) VALUE 4.                   REA01480
       01  W06-CSQ4-ERROR          PIC S9(4) VALUE 8.                   REA01490
      *                                                                 REA01500
      * call parameters for program UTIMEDSP                            REA01510
       01  WS-UTIMEDSP.                                                 REA01520
           05 WS-UTIMEDSP-STCK        PIC X(8).                         REA01530
           05 WS-UTIMEDSP-DISPLAY     PIC X(12).                        REA01540
       01  WS-BLANK9                  PIC X(9) VALUE SPACES.            REA01550
      *                                                                 REA01560
      * date/time data descriptions                                     REA01570
       01  WS-DATE.                                                     REA01580
           05 WS-DATE-YY              PIC 99.                           REA01590
           05 WS-DATE-MM              PIC 99.                           REA01600
           05 WS-DATE-DD              PIC 99.                           REA01610
       01  WS-TIME.                                                     REA01620
           05 WS-TIME-HOUR            PIC 99.                           REA01630
           05 WS-TIME-MIN             PIC 99.                           REA01640
           05 WS-TIME-SEC             PIC 99.                           REA01650
           05 WS-TIME-HUND            PIC 99.                           REA01660
       01  WS-TIME1.                                                    REA01670
           05 WS-TIME1-HOUR           PIC 99.                           REA01680
           05 WS-TIME1-MIN            PIC 99.                           REA01690
           05 WS-TIME1-SEC            PIC 99.                           REA01700
           05 WS-TIME1-HUND           PIC 99.                           REA01710
       01  WS-TIME2.                                                    REA01720
           05 WS-TIME2-HOUR           PIC 99.                           REA01730
           05 WS-TIME2-MIN            PIC 99.                           REA01740
           05 WS-TIME2-SEC            PIC 99.                           REA01750
           05 WS-TIME2-HUND           PIC 99.                           REA01760
       01  WS-TIME-TOTAL              PIC 9(8).                         REA01770
       01  WS-TIME-TOTAL1             PIC 9(8).                         REA01780
       01  WS-TIME-TOTAL2             PIC 9(8).                         REA01790
       01  WS-DAY-OF-WEEK             PIC 9.                            REA01800
       01  WS-DAY.                                                      REA01810
           05 WS-DAY-YY               PIC 99.                           REA01820
           05 WS-DAY-DDD              PIC 999.                          REA01830
      * work areas for MQSeries api calls                               REA01840
      *                                                                 REA01850
       01  WS-NAME                    PIC X(48).                        REA01860
       01  WS-HCONN                   PIC S9(9) BINARY.                 REA01870
       01  WS-HOBJ                    PIC S9(9) BINARY.                 REA01880
       01  WS-BUFFLEN                 PIC S9(9) BINARY VALUE ZEROS.     REA01890
       01  WS-DATALEN                 PIC S9(9) BINARY VALUE ZEROS.     REA01900
       01  WS-OPTIONS                 PIC S9(9) BINARY.                 REA01910
       01  WS-INTCOUNT                PIC S9(9) BINARY.                 REA01920
       01  WS-SELCOUNT                PIC S9(9) BINARY.                 REA01930
       01  WS-CHARCOUNT               PIC S9(9) BINARY.                 REA01940
       01  WS-CHARLEN                 PIC S9(9) BINARY.                 REA01950
       01  WS-SEL                     PIC S9(9) BINARY.                 REA01960
       01  WS-VERSION                 PIC S9(9) BINARY.                 REA01970
       01  WS-COMPCODE                PIC S9(9) BINARY.                 REA01980
       01  WS-REASON                  PIC S9(9) BINARY.                 REA01990
       01  WS-BUFFER-AREA.                                              REA02000
           05 WS-BUFFER-AREA-CHAR     PIC X OCCURS 4194304.             REA02010
       01  WS-BIN-NUMBERS1.                                             REA02020
           05 WS-BIN-NUM1             PIC S9(9) BINARY OCCURS 100.      REA02030
       01  WS-BIN-NUMBERS2.                                             REA02040
           05 WS-BIN-NUM2             PIC S9(9) BINARY OCCURS 100.      REA02050
      *                                                                 REA02060
      * work areas for MQSeries api calls end                           REA02070
      *                                                                 REA02080
      *                                                                 REA02090
       01  WS-TIME-DISPLAY.                                             REA02100
           05 WS-TIME-DISPLAY-HOUR    PIC 99.                           REA02110
           05 FILLER                  PIC X VALUE ':'.                  REA02120
           05 WS-TIME-DISPLAY-MIN     PIC 99.                           REA02130
           05 FILLER                  PIC X VALUE ':'.                  REA02140
           05 WS-TIME-DISPLAY-SEC     PIC 99.                           REA02150
           05 FILLER                  PIC X VALUE ':'.                  REA02160
           05 WS-TIME-DISPLAY-HUND    PIC 99.                           REA02170
      *                                                                 REA02180
       01  WS-TEXT-TITLE              PIC X(30) VALUE SPACES.           REA02190
       01  WS-TEXT                    PIC X(30) VALUE SPACES.           REA02200
       01  WS-XTOCHAR-LEN             PIC S9(9) COMP VALUE ZEROS.       REA02210
       01  WS-LONG-HEXDISP            PIC X(8).                         REA02220
      *                                                                 REA02230
      ******************************************************************REA02240
      * Declare a work buffer for processing a sub-structure within the REA02250
      * PCF message.                                                    REA02260
      ******************************************************************REA02270
       01  WORK-BUF PIC X(1000).                                        REA02280
      * MQCFH substructure                                              REA02290
       01  CFH-BUF REDEFINES WORK-BUF.                                  REA02300
        02  CFH-HDR.                                                    REA02310
            COPY CMQCFHL.                                               REA02320
      * MQCFIN substructure                                             REA02330
       01  CFIN-BUF REDEFINES WORK-BUF.                                 REA02340
        02  CFIN-HDR.                                                   REA02350
            COPY CMQCFINL.                                              REA02360
      * MQCFIL substructure                                             REA02370
       01  CFIL-BUF REDEFINES WORK-BUF.                                 REA02380
        02  CFIL-HDR.                                                   REA02390
            COPY CMQCFILL.                                              REA02400
        02  CFIL-DATA PIC S9(9) BINARY OCCURS 50 TIMES.                 REA02410
      * MQCFST substructure                                             REA02420
       01  CFST-BUF REDEFINES WORK-BUF.                                 REA02430
        02  CFST-HDR.                                                   REA02440
            COPY CMQCFSTL.                                              REA02450
        02  CFST-DATA PIC X(64).                                        REA02460
      * MQCFSL substructure                                             REA02470
       01  CFSL-BUF REDEFINES WORK-BUF.                                 REA02480
        02  CFSL-HDR.                                                   REA02490
            COPY CMQCFSLL.                                              REA02500
        02  CFSL-DATA PIC X(400).                                       REA02510
      *                                                                 REA02520
      ******************************************************************REA02530
      * Declare certain variables as both char and num. (PCF processing)REA02540
      ******************************************************************REA02550
      * Structure length                                                REA02560
       01  STRUC-LEN-CHAR.                                              REA02570
        02  STRUC-LEN PIC S9(9) BINARY.                                 REA02580
            88 WS-START-MESSAGE VALUE 2282.                             REA02590
            88 WS-STOP-MESSAGE  VALUE 2283.                             REA02600
      *                                                                 REA02610
      ******************************************************************REA02620
      * Declare other simple variables. (PCF processing)                REA02630
      ******************************************************************REA02640
       01  WS-PCF.                                                      REA02650
        10  FIRST-BYTE PIC S9(9) BINARY.                                REA02660
        10  PARM-COUNT PIC S9(9) BINARY.                                REA02670
        10  J          PIC S9(9) BINARY.                                REA02680
        10  K          PIC S9(9) BINARY.                                REA02690
        10  L          PIC S9(9) BINARY.                                REA02700
      *                                                                 REA02710
       01  MQ-PCF-CONS.                                                 REA02720
           COPY CMQCFV.                                                 REA02730
      *                                                                 REA02740
      *                                                                 REA02750
      *                                                                 REA02760
      * ------------------------------------------------------------- * REA02770
       LINKAGE SECTION.                                                 REA02780
      * ------------------------------------------------------------- * REA02790
       01  PARMDATA.                                                    REA02800
           05  PARM-LEN                PIC S9(03) BINARY.               REA02810
           05  PARM-STRING             PIC X(100).                      REA02820
      *                                                                 REA02830
           EJECT                                                        REA02840
      * ------------------------------------------------------------- * REA02850
       PROCEDURE DIVISION USING PARMDATA.                               REA02860
      * ------------------------------------------------------------- * REA02870
      * ------------------------------------------------------------- * REA02880
       A-MAIN SECTION.                                                  REA02890
      * ------------------------------------------------------------- * REA02900
      *                                                                 REA02910
           ACCEPT W00-DATE FROM DATE.                                   REA02920
           MOVE W00-MM TO W01-MM.                                       REA02930
           MOVE W00-DD TO W01-DD.                                       REA02940
           MOVE W00-YY TO W01-YY.                                       REA02950
      *                                                                 REA02960
           DISPLAY '================================================'   REA02970
                   '================================================'.  REA02980
           DISPLAY W01-HEADER-1.                                        REA02990
      *                                                                 REA03000
           PERFORM ACCEPT-TIME.                                         REA03010
           DISPLAY '          ' WS-TIME-DISPLAY.                        REA03020
      *                                                                 REA03030
      *    If no data was passed, create a message, print it, and       REA03040
      *    exit                                                         REA03050
      *                                                                 REA03060
           IF PARM-LEN = 0 THEN                                         REA03070
              DISPLAY W04-MESSAGE-1                                     REA03080
              MOVE W06-CSQ4-WARNING TO W00-RETURN-CODE                  REA03090
              GO TO A-MAIN-END                                          REA03100
           END-IF.                                                      REA03110
      *                                                                 REA03120
      *    Separate into the relevant fields any data passed in the     REA03130
      *    PARM statement                                               REA03140
      *                                                                 REA03150
           UNSTRING PARM-STRING DELIMITED BY ALL ','                    REA03160
                                   INTO W02-MQM                         REA03170
                                        W02-OBJECT.                     REA03180
      *                                                                 REA03190
      *    Move the data (spaces if nothing is entered) into the        REA03200
      *    relevant print fields                                        REA03210
      *                                                                 REA03220
           MOVE W02-MQM    TO W01-MQM-NAME.                             REA03230
           MOVE W02-OBJECT TO W01-QUEUE-NAME.                           REA03240
      *                                                                 REA03250
      *    Print a message if the queue manager name is missing, the    REA03260
      *    default queue manager will be used                           REA03270
      *                                                                 REA03280
           IF W02-MQM = SPACES OR W02-MQM = LOW-VALUES THEN             REA03290
              DISPLAY W04-MESSAGE-2                                     REA03300
           END-IF.                                                      REA03310
      *                                                                 REA03320
      *    Print a message if the queue name is missing and exit from   REA03330
      *    program                                                      REA03340
      *                                                                 REA03350
           IF W02-OBJECT = SPACES OR W02-OBJECT = LOW-VALUES THEN       REA03360
              DISPLAY W04-MESSAGE-3                                     REA03370
              MOVE W06-CSQ4-WARNING TO W00-RETURN-CODE                  REA03380
              GO TO A-MAIN-END                                          REA03390
           END-IF.                                                      REA03400
      *                                                                 REA03410
      *    Print the remaining header lines                             REA03420
      *                                                                 REA03430
           DISPLAY W01-HEADER-2.                                        REA03440
           DISPLAY W01-HEADER-3.                                        REA03450
           DISPLAY W01-HEADER-4.                                        REA03460
      *                                                                 REA03470
      *    Connect to the specified queue manager.                      REA03480
      *                                                                 REA03490
           CALL 'MQCONN' USING W02-MQM                                  REA03500
                               W03-HCONN                                REA03510
                               W03-COMPCODE                             REA03520
                               W03-REASON.                              REA03530
      *                                                                 REA03540
      *    Test the output of the connect call.  If the call failed,    REA03550
      *    print an error message showing the completion code and       REA03560
      *    reason code                                                  REA03570
      *                                                                 REA03580
           IF (W03-COMPCODE NOT = MQCC-OK) THEN                         REA03590
              MOVE 'CONNECT'     TO W04-MSG4-TYPE                       REA03600
              MOVE W03-COMPCODE  TO W04-MSG4-COMPCODE                   REA03610
              MOVE W03-REASON    TO W04-MSG4-REASON                     REA03620
              DISPLAY W04-MESSAGE-4                                     REA03630
              MOVE W06-CSQ4-ERROR TO W00-RETURN-CODE                    REA03640
              GO TO A-MAIN-END                                          REA03650
           END-IF.                                                      REA03660
      *                                                                 REA03670
      *    Initialize the object descriptor (MQOD) control block.       REA03680
      *    (The copy file initializes all the other fields)             REA03690
      *                                                                 REA03700
           MOVE MQOT-Q            TO MQOD-OBJECTTYPE.                   REA03710
           MOVE W02-OBJECT        TO MQOD-OBJECTNAME.                   REA03720
      *                                                                 REA03730
      *    Initialize the working storage fields required to open       REA03740
      *    the queue                                                    REA03750
      *                                                                 REA03760
           MOVE MQOO-BROWSE       TO W03-OPTIONS.                       REA03770
      *                                                                 REA03780
      *    Open the queue.                                              REA03790
      *                                                                 REA03800
           CALL 'MQOPEN' USING W03-HCONN                                REA03810
                               MQOD                                     REA03820
                               W03-OPTIONS                              REA03830
                               W03-HOBJ                                 REA03840
                               W03-COMPCODE                             REA03850
                               W03-REASON.                              REA03860
           IF (W03-COMPCODE NOT = MQCC-OK) THEN                         REA03870
              MOVE 'OPEN'        TO W04-MSG4-TYPE                       REA03880
              MOVE W03-COMPCODE  TO W04-MSG4-COMPCODE                   REA03890
              MOVE W03-REASON    TO W04-MSG4-REASON                     REA03900
              DISPLAY W04-MESSAGE-4                                     REA03910
              MOVE W06-CSQ4-ERROR TO W00-RETURN-CODE                    REA03920
              GO TO A-MAIN-DISCONNECT                                   REA03930
           END-IF.                                                      REA03940
      *                                                                 REA03950
      *    Initialize the Get Message Options (MQGMO) control block.    REA03960
      *    (The copy file initializes all the other fields)             REA03970
      *                                                                 REA03980
           MOVE MQGMO-NO-WAIT              TO MQGMO-OPTIONS.            REA03990
           ADD  MQGMO-ACCEPT-TRUNCATED-MSG TO MQGMO-OPTIONS.            REA04000
           ADD  MQGMO-BROWSE-FIRST         TO MQGMO-OPTIONS.            REA04010
      *                                                                 REA04020
      *    Make the first get call outside the loop because this call   REA04030
      *    uses the BROWSE-FIRST option                                 REA04040
      *                                                                 REA04050
           CALL 'MQGET' USING W03-HCONN                                 REA04060
                              W03-HOBJ                                  REA04070
                              MQMD                                      REA04080
                              MQGMO                                     REA04090
                              W03-BUFFER-LENGTH                         REA04100
                              W03-MESSAGE-DATA                          REA04110
                              W03-DATA-LENGTH                           REA04120
                              W03-COMPCODE                              REA04130
                              W03-REASON.                               REA04140
      *                                                                 REA04150
      *    Test the output of the get call using the PERFORM loop       REA04160
      *    that follows.                                                REA04170
      *                                                                 REA04180
      *    Change the MQGMO Options field to BROWSE-NEXT.               REA04190
      *                                                                 REA04200
           MOVE MQGMO-NO-WAIT              TO MQGMO-OPTIONS.            REA04210
           ADD  MQGMO-ACCEPT-TRUNCATED-MSG TO MQGMO-OPTIONS.            REA04220
           ADD  MQGMO-BROWSE-NEXT          TO MQGMO-OPTIONS.            REA04230
      *                                                                 REA04240
      *    Loop from here to END-PERFORM until the get call fails       REA04250
      *                                                                 REA04260
           PERFORM WITH TEST BEFORE                                     REA04270
                   UNTIL W03-COMPCODE NOT = MQCC-OK                     REA04280
      *                                                                 REA04290
      *       Increment the relative message number.  Move the message  REA04300
      *       number and the message data into the print line           REA04310
      *                                                                 REA04320
              ADD 1                  TO W00-MESSAGE-COUNT               REA04330
              DISPLAY '*********************************************'   REA04340
              DISPLAY 'Message number ' W00-MESSAGE-COUNT               REA04350
      *                                                                 REA04360
      *       Print the message line                                    REA04370
      *                                                                 REA04380
              PERFORM DISPLAY-MESSAGE                                   REA04390
      *                                                                 REA04400
      *                                                                 REA04410
              MOVE MQMI-NONE TO MQMD-MSGID                              REA04420
              MOVE MQCI-NONE TO MQMD-CORRELID                           REA04430
      *                                                                 REA04440
      *    Clear the message data field before the next get call to     REA04450
      *    ensure that no old data remains if the next line is shorter  REA04460
      *                                                                 REA04470
              MOVE SPACES TO W03-MESSAGE-DATA                           REA04480
      *                                                                 REA04490
      *       Get the next message                                      REA04500
      *                                                                 REA04510
              CALL 'MQGET' USING W03-HCONN                              REA04520
                                 W03-HOBJ                               REA04530
                                 MQMD                                   REA04540
                                 MQGMO                                  REA04550
                                 W03-BUFFER-LENGTH                      REA04560
                                 W03-MESSAGE-DATA                       REA04570
                                 W03-DATA-LENGTH                        REA04580
                                 W03-COMPCODE                           REA04590
                                 W03-REASON                             REA04600
      *                                                                 REA04610
      *       Test the output of the MQGET call at the top of the loop. REA04620
      *       Exit the loop if an error occurs                          REA04630
      *                                                                 REA04640
           END-PERFORM.                                                 REA04650
      *                                                                 REA04660
      *                                                                 REA04670
           IF (W03-COMPCODE = MQCC-FAILED)  AND                         REA04680
              (W03-REASON = MQRC-NO-MSG-AVAILABLE) THEN                 REA04690
      *                                                                 REA04700
              DISPLAY W04-MESSAGE-0                                     REA04710
      *                                                                 REA04720
           ELSE                                                         REA04730
              MOVE 'GET'         TO W04-MSG4-TYPE                       REA04740
              MOVE W03-COMPCODE  TO W04-MSG4-COMPCODE                   REA04750
              MOVE W03-REASON    TO W04-MSG4-REASON                     REA04760
              DISPLAY W04-MESSAGE-4                                     REA04770
              MOVE W06-CSQ4-ERROR TO W00-RETURN-CODE                    REA04780
           END-IF.                                                      REA04790
      *                                                                 REA04800
       A-MAIN-DISCONNECT.                                               REA04810
           CALL 'MQDISC' USING W03-HCONN                                REA04820
                               W03-COMPCODE                             REA04830
                               W03-REASON.                              REA04840
      *                                                                 REA04850
           IF (W03-COMPCODE NOT = MQCC-OK) THEN                         REA04860
              MOVE 'DISCONNECT'  TO W04-MSG4-TYPE                       REA04870
              MOVE W03-COMPCODE  TO W04-MSG4-COMPCODE                   REA04880
              MOVE W03-REASON    TO W04-MSG4-REASON                     REA04890
              DISPLAY W04-MESSAGE-4                                     REA04900
           END-IF.                                                      REA04910
      *                                                                 REA04920
       A-MAIN-END.                                                      REA04930
      *                                                                 REA04940
      *    Set the return code                                          REA04950
      *                                                                 REA04960
           MOVE W00-RETURN-CODE TO RETURN-CODE.                         REA04970
      *                                                                 REA04980
           STOP RUN.                                                    REA04990
      ******************************************************************REA05000
      * This program prepares to analyse the PCF message in COBOL,      REA05010
      ******************************************************************REA05020
       DISPLAY-MESSAGE SECTION.                                         REA05030
      *                                                                 REA05040
      * Check msg is a valid PCF reply message                          REA05050
           MOVE W03-MESSAGE-DATA(5:4) TO STRUC-LEN-CHAR                 REA05060
           IF STRUC-LEN NOT = MQCFH-STRUC-LENGTH                        REA05070
              DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                     REA05080
                      'MESSAGE IS NOT IN PCF FORMAT'                    REA05090
              DISPLAY WS-TIME-DISPLAY 'Invalid message format bypassed' REA05100
              GO TO DISPLAY-MESSAGE-END.                                REA05110
           MOVE W03-MESSAGE-DATA(9:4) TO STRUC-LEN-CHAR                 REA05120
           IF STRUC-LEN NOT = MQCFH-VERSION-1                           REA05130
              DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                     REA05140
                      'MESSAGE IS NOT IN PCF FORMAT'                    REA05150
              DISPLAY WS-TIME-DISPLAY 'Invalid message format bypassed' REA05160
              GO TO DISPLAY-MESSAGE-END.                                REA05170
      *                                                                 REA05180
           MOVE W03-MESSAGE-DATA(29:4) TO STRUC-LEN-CHAR.               REA05190
           IF WS-START-MESSAGE                                          REA05200
              MOVE MQMD-PUTTIME(1:2) TO WS-TIME-DISPLAY-HOUR            REA05210
              MOVE MQMD-PUTTIME(3:2) TO WS-TIME-DISPLAY-MIN             REA05220
              MOVE MQMD-PUTTIME(5:2) TO WS-TIME-DISPLAY-SEC             REA05230
              MOVE MQMD-PUTTIME(7:2) TO WS-TIME-DISPLAY-HUND            REA05240
              DISPLAY '  START EVENT '                                  REA05250
                      'sent on ' MQMD-PUTDATE ' at ' WS-TIME-DISPLAY    REA05260
              PERFORM ACCEPT-TIME                                       REA05270
              PERFORM START-STOP-EVENT                                  REA05280
              GO TO DISPLAY-MESSAGE-END.                                REA05290
      *                                                                 REA05300
           IF WS-STOP-MESSAGE                                           REA05310
              MOVE MQMD-PUTTIME(1:2) TO WS-TIME-DISPLAY-HOUR            REA05320
              MOVE MQMD-PUTTIME(3:2) TO WS-TIME-DISPLAY-MIN             REA05330
              MOVE MQMD-PUTTIME(5:2) TO WS-TIME-DISPLAY-SEC             REA05340
              MOVE MQMD-PUTTIME(7:2) TO WS-TIME-DISPLAY-HUND            REA05350
              DISPLAY '  STOP EVENT  '                                  REA05360
                      'sent on ' MQMD-PUTDATE ' at ' WS-TIME-DISPLAY    REA05370
              PERFORM ACCEPT-TIME                                       REA05380
              PERFORM START-STOP-EVENT                                  REA05390
              GO TO DISPLAY-MESSAGE-END.                                REA05400
      *                                                                 REA05410
           PERFORM DISPLAY-EVENT-MESSAGE.                               REA05420
      *                                                                 REA05430
       DISPLAY-MESSAGE-END.                                             REA05440
           EXIT.                                                        REA05450
      ******************************************************************REA05460
      * This program analyses a START/STOP EVENT message                REA05470
      ******************************************************************REA05480
       START-STOP-EVENT SECTION.                                        REA05490
      *                                                                 REA05500
      * Initialise index and length for processing loop                 REA05510
           MOVE 1 TO FIRST-BYTE.                                        REA05520
           MOVE MQCFH-STRUC-LENGTH   TO STRUC-LEN.                      REA05530
           MOVE W03-MESSAGE-DATA(FIRST-BYTE:STRUC-LEN) TO WORK-BUF      REA05540
           MOVE MQCFH-PARAMETERCOUNT TO PARM-COUNT                      REA05550
      *                                                                 REA05560
           EVALUATE MQCFH-COMPCODE OF MQCFH                             REA05570
               WHEN MQCC-OK                                             REA05580
                   MOVE 'MQCC-OK' TO WS-TEXT                            REA05590
               WHEN MQCC-WARNING                                        REA05600
                   MOVE 'MQCC-WARNING' TO WS-TEXT                       REA05610
               WHEN MQCC-FAILED                                         REA05620
                   MOVE 'MQCC-FAILED' TO WS-TEXT                        REA05630
               WHEN OTHER                                               REA05640
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA05650
           END-EVALUATE.                                                REA05660
           DISPLAY '  MQCFH-COMPCODE = ' WS-TEXT.                       REA05670
      *                                                                 REA05680
      * Process each sub-structure in msg                               REA05690
           PERFORM TEST BEFORE VARYING J FROM 1 BY 1                    REA05700
             UNTIL (J > PARM-COUNT)                                     REA05710
      * Compute index of start of next sub-structure                    REA05720
           COMPUTE FIRST-BYTE = FIRST-BYTE + STRUC-LEN                  REA05730
      * Compute start of length field (offset 4 from start of structure)REA05740
           COMPUTE K = FIRST-BYTE + 4                                   REA05750
      * Get length of sub-structure                                     REA05760
           MOVE W03-MESSAGE-DATA(K:4) TO STRUC-LEN-CHAR                 REA05770
      * Copy sub-structure into work buffer                             REA05780
           MOVE W03-MESSAGE-DATA(FIRST-BYTE:STRUC-LEN) TO WORK-BUF      REA05790
      * Process sub-structure according to type                         REA05800
           IF MQCFIN-TYPE = MQCFT-INTEGER THEN                          REA05810
              PERFORM DISPLAY-SSTOP-INTEGER-STRUC                       REA05820
           ELSE IF MQCFIL-TYPE = MQCFT-INTEGER-LIST THEN                REA05830
              PERFORM DISPLAY-INTEGER-LIST-STRUC                        REA05840
           ELSE IF MQCFST-TYPE = MQCFT-STRING THEN                      REA05850
              PERFORM DISPLAY-SSTOP-STRING-STRUC                        REA05860
           ELSE IF MQCFSL-TYPE = MQCFT-STRING-LIST THEN                 REA05870
              PERFORM DISPLAY-STRING-LIST-STRUC                         REA05880
           ELSE                                                         REA05890
              DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                     REA05900
                      '** MESSAGE IS NO LONGER IN PCF FORMAT **'        REA05910
              GO TO START-STOP-EVENT-END                                REA05920
           END-IF END-IF END-IF END-IF                                  REA05930
      * End of loop                                                     REA05940
           END-PERFORM.                                                 REA05950
      *                                                                 REA05960
       START-STOP-EVENT-END.                                            REA05970
           EXIT.                                                        REA05980
      ******************************************************************REA05990
      * This program analyses a PCF / EVENT message in COBOL,           REA06000
      ******************************************************************REA06010
       DISPLAY-EVENT-MESSAGE SECTION.                                   REA06020
      *                                                                 REA06030
      * Initialise index and length for processing loop                 REA06040
           MOVE 1 TO FIRST-BYTE.                                        REA06050
           MOVE MQCFH-STRUC-LENGTH   TO STRUC-LEN.                      REA06060
           MOVE W03-MESSAGE-DATA(FIRST-BYTE:STRUC-LEN) TO WORK-BUF      REA06070
           MOVE MQCFH-PARAMETERCOUNT TO PARM-COUNT                      REA06080
      *                                                                 REA06090
           PERFORM DISPLAY-HEADER-STRUC.                                REA06100
      *                                                                 REA06110
      * Process each sub-structure in msg                               REA06120
           PERFORM TEST BEFORE VARYING J FROM 1 BY 1                    REA06130
             UNTIL (J > PARM-COUNT)                                     REA06140
      * Compute index of start of next sub-structure                    REA06150
           COMPUTE FIRST-BYTE = FIRST-BYTE + STRUC-LEN                  REA06160
      * Compute start of length field (offset 4 from start of structure)REA06170
           COMPUTE K = FIRST-BYTE + 4                                   REA06180
      * Get length of sub-structure                                     REA06190
           MOVE W03-MESSAGE-DATA(K:4) TO STRUC-LEN-CHAR                 REA06200
      * Copy sub-structure into work buffer                             REA06210
           MOVE W03-MESSAGE-DATA(FIRST-BYTE:STRUC-LEN) TO WORK-BUF      REA06220
      * Process sub-structure according to type                         REA06230
           IF MQCFIN-TYPE = MQCFT-INTEGER THEN                          REA06240
              PERFORM DISPLAY-INTEGER-STRUC                             REA06250
           ELSE IF MQCFIL-TYPE = MQCFT-INTEGER-LIST THEN                REA06260
              PERFORM DISPLAY-INTEGER-LIST-STRUC                        REA06270
           ELSE IF MQCFST-TYPE = MQCFT-STRING THEN                      REA06280
              PERFORM DISPLAY-STRING-STRUC                              REA06290
           ELSE IF MQCFSL-TYPE = MQCFT-STRING-LIST THEN                 REA06300
              PERFORM DISPLAY-STRING-LIST-STRUC                         REA06310
           ELSE                                                         REA06320
              DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                     REA06330
                      '** MESSAGE IS NO LONGER IN PCF FORMAT **'        REA06340
              GO TO DISPLAY-EVENT-MESSAGE-END                           REA06350
           END-IF END-IF END-IF END-IF                                  REA06360
      * End of loop                                                     REA06370
           END-PERFORM.                                                 REA06380
      *                                                                 REA06390
       DISPLAY-EVENT-MESSAGE-END.                                       REA06400
           EXIT.                                                        REA06410
      ******************************************************************REA06420
      * Process header structure.                                       REA06430
      ******************************************************************REA06440
       DISPLAY-HEADER-STRUC SECTION.                                    REA06450
           DISPLAY ' '                                                  REA06460
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA06470
                   'MQCFH structure'.                                   REA06480
      *                                                                 REA06490
           EVALUATE MQCFH-TYPE OF MQCFH                                 REA06500
               WHEN MQCFT-COMMAND                                       REA06510
                   MOVE 'COMMAND' TO WS-TEXT                            REA06520
               WHEN MQCFT-RESPONSE                                      REA06530
                   MOVE 'RESPONSE' TO WS-TEXT                           REA06540
               WHEN MQCFT-INTEGER                                       REA06550
                   MOVE 'INTEGER' TO WS-TEXT                            REA06560
               WHEN MQCFT-STRING                                        REA06570
                   MOVE 'STRING' TO WS-TEXT                             REA06580
               WHEN MQCFT-INTEGER-LIST                                  REA06590
                   MOVE 'INTEGER LIST' TO WS-TEXT                       REA06600
               WHEN MQCFT-STRING-LIST                                   REA06610
                   MOVE 'STRING-LIST' TO WS-TEXT                        REA06620
               WHEN MQCFT-EVENT                                         REA06630
                   MOVE 'EVENT' TO WS-TEXT                              REA06640
               WHEN OTHER                                               REA06650
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA06660
           END-EVALUATE.                                                REA06670
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA06680
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA06690
                                MQCFH-TYPE OF MQCFH                     REA06700
                                WS-LONG-HEXDISP.                        REA06710
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA06720
                   'MQCFH-TYPE             ='                           REA06730
                   'X''' WS-LONG-HEXDISP   ''''                         REA06740
                   ' ' MQCFH-TYPE OF MQCFH                              REA06750
                   ' ' WS-TEXT.                                         REA06760
      *                                                                 REA06770
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA06780
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA06790
                                MQCFH-STRUCLENGTH OF MQCFH              REA06800
                                WS-LONG-HEXDISP.                        REA06810
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA06820
                   'MQCFH-STRUCLENGTH      ='                           REA06830
                   'X''' WS-LONG-HEXDISP   ''''                         REA06840
                   ' ' MQCFH-STRUCLENGTH OF MQCFH.                      REA06850
      *                                                                 REA06860
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA06870
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA06880
                                MQCFH-VERSION OF MQCFH                  REA06890
                                WS-LONG-HEXDISP.                        REA06900
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA06910
                   'MQCFH-VERSION          ='                           REA06920
                   'X''' WS-LONG-HEXDISP   ''''                         REA06930
                   ' ' MQCFH-VERSION OF MQCFH.                          REA06940
      *                                                                 REA06950
           EVALUATE MQCFH-COMMAND OF MQCFH                              REA06960
               WHEN MQCMD-Q-MGR-EVENT                                   REA06970
                   MOVE 'QMGR EVENT' TO WS-TEXT                         REA06980
               WHEN MQCMD-PERFM-EVENT                                   REA06990
                   MOVE 'PERFORMANCE EVENT' TO WS-TEXT                  REA07000
               WHEN MQCMD-CHANNEL-EVENT                                 REA07010
                   MOVE 'CHANNEL EVENT' TO WS-TEXT                      REA07020
               WHEN OTHER                                               REA07030
                   MOVE '***OTHER***' TO WS-TEXT                        REA07040
           END-EVALUATE.                                                REA07050
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA07060
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA07070
                                MQCFH-COMMAND OF MQCFH                  REA07080
                                WS-LONG-HEXDISP.                        REA07090
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA07100
                   'MQCFH-COMMAND          ='                           REA07110
                   'X''' WS-LONG-HEXDISP   ''''                         REA07120
                   ' ' MQCFH-COMMAND OF MQCFH                           REA07130
                   ' ' WS-TEXT.                                         REA07140
      *                                                                 REA07150
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA07160
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA07170
                                MQCFH-MSGSEQNUMBER OF MQCFH             REA07180
                                WS-LONG-HEXDISP.                        REA07190
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA07200
                   'MQCFH-MSGSEQNUMBER     ='                           REA07210
                   'X''' WS-LONG-HEXDISP   ''''                         REA07220
                   ' ' MQCFH-MSGSEQNUMBER OF MQCFH.                     REA07230
      *                                                                 REA07240
           EVALUATE MQCFH-CONTROL OF MQCFH                              REA07250
               WHEN MQCFC-LAST                                          REA07260
                   MOVE 'LAST MESSAGE' TO WS-TEXT                       REA07270
               WHEN MQCFC-NOT-LAST                                      REA07280
                   MOVE 'NOT LAST MESSAGE' TO WS-TEXT                   REA07290
               WHEN OTHER                                               REA07300
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA07310
           END-EVALUATE.                                                REA07320
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA07330
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA07340
                                MQCFH-CONTROL OF MQCFH                  REA07350
                                WS-LONG-HEXDISP.                        REA07360
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA07370
                   'MQCFH-CONTROL          ='                           REA07380
                   'X''' WS-LONG-HEXDISP   ''''                         REA07390
                   ' ' MQCFH-CONTROL OF MQCFH                           REA07400
                   ' ' WS-TEXT.                                         REA07410
      *                                                                 REA07420
           EVALUATE MQCFH-COMPCODE OF MQCFH                             REA07430
               WHEN MQCC-OK                                             REA07440
                   MOVE 'MQCC-OK' TO WS-TEXT                            REA07450
               WHEN MQCC-WARNING                                        REA07460
                   MOVE 'MQCC-WARNING' TO WS-TEXT                       REA07470
               WHEN MQCC-FAILED                                         REA07480
                   MOVE 'MQCC-FAILED' TO WS-TEXT                        REA07490
               WHEN OTHER                                               REA07500
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA07510
           END-EVALUATE.                                                REA07520
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA07530
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA07540
                                MQCFH-COMPCODE OF MQCFH                 REA07550
                                WS-LONG-HEXDISP.                        REA07560
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA07570
                   'MQCFH-COMPCODE         ='                           REA07580
                   'X''' WS-LONG-HEXDISP   ''''                         REA07590
                   ' ' MQCFH-COMPCODE OF MQCFH                          REA07600
                   ' ' WS-TEXT.                                         REA07610
      *                                                                 REA07620
           EVALUATE MQCFH-REASON OF MQCFH                               REA07630
               WHEN MQRC-GET-INHIBITED                                  REA07640
                   MOVE 'GET INHIBITED' TO WS-TEXT                      REA07650
               WHEN MQRC-PUT-INHIBITED                                  REA07660
                   MOVE 'PUT INHIBITED' TO WS-TEXT                      REA07670
               WHEN MQRC-ALIAS-BASE-Q-TYPE-ERROR                        REA07680
                   MOVE 'ALIAS BASE Q TYPE ERROR' TO WS-TEXT            REA07690
               WHEN MQRC-UNKNOWN-ALIAS-BASE-Q                           REA07700
                   MOVE 'UNKNOWN ALIAS BASE Q' TO WS-TEXT               REA07710
               WHEN MQRC-UNKNOWN-OBJECT-NAME                            REA07720
                   MOVE 'UNKNOWN OBJECT NAME' TO WS-TEXT                REA07730
               WHEN MQRC-DEF-XMIT-Q-TYPE-ERROR                          REA07740
                   MOVE 'DEF XMIT Q TYPE ERROR' TO WS-TEXT              REA07750
               WHEN MQRC-DEF-XMIT-Q-USAGE-ERROR                         REA07760
                   MOVE 'DEF XMIT Q USAGE ERROR' TO WS-TEXT             REA07770
               WHEN MQRC-Q-TYPE-ERROR                                   REA07780
                   MOVE 'Q TYPE ERROR' TO WS-TEXT                       REA07790
               WHEN MQRC-REMOTE-Q-NAME-ERROR                            REA07800
                   MOVE 'REMOTE Q NAME ERROR' TO WS-TEXT                REA07810
               WHEN MQRC-UNKNOWN-DEF-XMIT-Q                             REA07820
                   MOVE 'UNKNOWN DEF XMIT Q' TO WS-TEXT                 REA07830
               WHEN MQRC-UNKNOWN-REMOTE-Q-MGR                           REA07840
                   MOVE 'UNKNOWN REMOTE Q MGR' TO WS-TEXT               REA07850
               WHEN MQRC-UNKNOWN-XMIT-Q                                 REA07860
                   MOVE 'UNKNOWN XMIT Q' TO WS-TEXT                     REA07870
               WHEN MQRC-XMIT-Q-TYPE-ERROR                              REA07880
                   MOVE 'XMIT Q TYPE ERROR' TO WS-TEXT                  REA07890
               WHEN MQRC-XMIT-Q-USAGE-ERROR                             REA07900
                   MOVE 'XMIT Q USAGE ERROR' TO WS-TEXT                 REA07910
               WHEN MQRC-CHANNEL-STARTED                                REA07920
                   MOVE 'CHANNEL STARTED' TO WS-TEXT                    REA07930
               WHEN MQRC-CHANNEL-STOPPED                                REA07940
                   MOVE 'CHANNEL STOPPED' TO WS-TEXT                    REA07950
               WHEN OTHER                                               REA07960
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA07970
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA07980
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA07990
                                MQCFH-REASON OF MQCFH                   REA08000
                                WS-LONG-HEXDISP.                        REA08010
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA08020
                   'MQCFH-REASON           ='                           REA08030
                   'X''' WS-LONG-HEXDISP   ''''                         REA08040
                   ' ' MQCFH-REASON OF MQCFH                            REA08050
                   ' ' WS-TEXT.                                         REA08060
      *                                                                 REA08070
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA08080
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA08090
                                MQCFH-PARAMETERCOUNT OF MQCFH           REA08100
                                WS-LONG-HEXDISP.                        REA08110
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA08120
                   'MQCFH-PARAMETERCOUNT   ='                           REA08130
                   'X''' WS-LONG-HEXDISP   ''''                         REA08140
                   ' ' MQCFH-PARAMETERCOUNT OF MQCFH.                   REA08150
       DISPLAY-HEADER-STRUC-END.                                        REA08160
           EXIT.                                                        REA08170
      ******************************************************************REA08180
      * Process integer structure.                                      REA08190
      ******************************************************************REA08200
       DISPLAY-INTEGER-STRUC SECTION.                                   REA08210
           DISPLAY ' '                                                  REA08220
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA08230
                   'MQCFIN structure'.                                  REA08240
      *                                                                 REA08250
           EVALUATE MQCFIN-TYPE OF MQCFIN                               REA08260
               WHEN MQCFT-COMMAND                                       REA08270
                   MOVE 'COMMAND' TO WS-TEXT                            REA08280
               WHEN MQCFT-RESPONSE                                      REA08290
                   MOVE 'RESPONSE' TO WS-TEXT                           REA08300
               WHEN MQCFT-INTEGER                                       REA08310
                   MOVE 'INTEGER' TO WS-TEXT                            REA08320
               WHEN MQCFT-STRING                                        REA08330
                   MOVE 'STRING' TO WS-TEXT                             REA08340
               WHEN MQCFT-INTEGER-LIST                                  REA08350
                   MOVE 'INTEGER LIST' TO WS-TEXT                       REA08360
               WHEN MQCFT-STRING-LIST                                   REA08370
                   MOVE 'STRING-LIST' TO WS-TEXT                        REA08380
               WHEN MQCFT-EVENT                                         REA08390
                   MOVE 'EVENT' TO WS-TEXT                              REA08400
               WHEN OTHER                                               REA08410
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA08420
           END-EVALUATE.                                                REA08430
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA08440
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA08450
                                MQCFIN-TYPE OF MQCFIN                   REA08460
                                WS-LONG-HEXDISP.                        REA08470
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA08480
                   'MQCFIN-TYPE            ='                           REA08490
                   'X''' WS-LONG-HEXDISP   ''''                         REA08500
                   ' ' MQCFIN-TYPE OF MQCFIN                            REA08510
                   ' ' WS-TEXT.                                         REA08520
      *                                                                 REA08530
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA08540
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA08550
                                MQCFIN-STRUCLENGTH OF MQCFIN            REA08560
                                WS-LONG-HEXDISP.                        REA08570
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA08580
                   'MQCFIN-STRUCLENGTH     ='                           REA08590
                   'X''' WS-LONG-HEXDISP   ''''                         REA08600
                   ' ' MQCFIN-STRUCLENGTH OF MQCFIN.                    REA08610
      *                                                                 REA08620
      * parameter                                                       REA08630
           EVALUATE MQCFIN-PARAMETER OF MQCFIN                          REA08640
               WHEN MQIA-APPL-TYPE                                      REA08650
                   MOVE 'MQIA-APPL-TYPE' TO WS-TEXT                     REA08660
               WHEN MQIA-Q-TYPE                                         REA08670
                   MOVE 'MQIA-Q-TYPE' TO WS-TEXT                        REA08680
               WHEN MQIA-TIME-SINCE-RESET                               REA08690
                   MOVE 'MQIA-TIME-SINCE-RESET' TO WS-TEXT              REA08700
               WHEN MQIA-HIGH-Q-DEPTH                                   REA08710
                   MOVE 'MQIA-HIGH-Q-DEPTH' TO WS-TEXT                  REA08720
               WHEN MQIA-MSG-DEQ-COUNT                                  REA08730
                   MOVE 'MQIA-MSG-DEQ-COUNT     ' TO WS-TEXT            REA08740
               WHEN MQIA-MSG-ENQ-COUNT                                  REA08750
                   MOVE 'MQIA-MSG-ENQ-COUNT     ' TO WS-TEXT            REA08760
               WHEN MQIACF-ERROR-IDENTIFIER                             REA08770
                   MOVE 'MQIACF-ERROR-IDENTIFIER' TO WS-TEXT            REA08780
               WHEN MQIACF-REASON-QUALIFIER                             REA08790
                   MOVE 'MQIACF-REASON-QUALIFIER' TO WS-TEXT            REA08800
               WHEN MQIACF-AUX-ERROR-DATA-INT-1                         REA08810
                   MOVE 'MQIACF-AUX-ERROR-DATA-INT-1' TO WS-TEXT        REA08820
               WHEN MQIACF-AUX-ERROR-DATA-INT-2                         REA08830
                   MOVE 'MQIACF-AUX-ERROR-DATA-INT-2' TO WS-TEXT        REA08840
               WHEN OTHER                                               REA08850
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA08860
           END-EVALUATE.                                                REA08870
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA08880
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA08890
                                MQCFIN-PARAMETER OF MQCFIN              REA08900
                                WS-LONG-HEXDISP.                        REA08910
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA08920
                   'MQCFIN-PARAMETER       ='                           REA08930
                   'X''' WS-LONG-HEXDISP   ''''                         REA08940
                   ' ' MQCFIN-PARAMETER OF MQCFIN                       REA08950
                   ' ' WS-TEXT.                                         REA08960
      *                                                                 REA08970
      * value                                                           REA08980
           MOVE SPACES TO WS-TEXT.                                      REA08990
           IF MQCFIN-PARAMETER OF MQCFIN = MQIA-APPL-TYPE               REA09000
              EVALUATE MQCFIN-VALUE OF MQCFIN                           REA09010
                  WHEN MQAT-CICS                                        REA09020
                      MOVE 'CICS' TO WS-TEXT                            REA09030
                  WHEN MQAT-IMS                                         REA09040
                      MOVE 'IMS' TO WS-TEXT                             REA09050
                  WHEN MQAT-MVS                                         REA09060
                      MOVE 'MVS BATCH' TO WS-TEXT                       REA09070
                  WHEN MQAT-QMGR                                        REA09080
                      MOVE 'QMGR' TO WS-TEXT                            REA09090
                  WHEN MQQT-ALIAS                                       REA09100
                      MOVE 'MQQT-ALIAS' TO WS-TEXT                      REA09110
                  WHEN MQQT-REMOTE                                      REA09120
                      MOVE 'MQQT-REMOTE' TO WS-TEXT                     REA09130
                  WHEN MQRQ-Q-MGR-QUIESCING                             REA09140
                      MOVE 'MQRQ-Q-MGR-QUIESCING' TO WS-TEXT            REA09150
                  WHEN MQRQ-Q-MGR-STOPPING                              REA09160
                      MOVE 'MQRQ-Q-MGR-STOPPING ' TO WS-TEXT            REA09170
                  WHEN OTHER                                            REA09180
                      MOVE '***OTHER***' TO WS-TEXT                     REA09190
              END-EVALUATE                                              REA09200
           END-IF.                                                      REA09210
           IF MQCFIN-PARAMETER OF MQCFIN = MQIACF-REASON-QUALIFIER      REA09220
              EVALUATE MQCFIN-VALUE OF MQCFIN                           REA09230
                  WHEN MQRQ-CHANNEL-STOPPED-OK                          REA09240
                      MOVE 'MQRQ-CHANNEL-OK-STOP' TO WS-TEXT            REA09250
                  WHEN MQRQ-CHANNEL-STOPPED-ERROR                       REA09260
                      MOVE 'MQRQ-CHANNEL-ERROR-STOP' TO WS-TEXT         REA09270
                  WHEN MQRQ-CHANNEL-STOPPED-RETRY                       REA09280
                      MOVE 'MQRQ-CHANNEL-RETRY-STOP' TO WS-TEXT         REA09290
                  WHEN MQRQ-CHANNEL-STOPPED-DISABLED                    REA09300
                      MOVE 'MQRQ-CHANNEL-DISABLED-STOP' TO WS-TEXT      REA09310
                  WHEN OTHER                                            REA09320
                      MOVE '**UNKNOWN**' TO WS-TEXT                     REA09330
              END-EVALUATE                                              REA09340
           END-IF.                                                      REA09350
           IF MQCFIN-PARAMETER OF MQCFIN = MQIA-Q-TYPE                  REA09360
              EVALUATE MQCFIN-VALUE OF MQCFIN                           REA09370
                  WHEN MQQT-LOCAL                                       REA09380
                      MOVE 'LOCAL QUEUE' TO WS-TEXT                     REA09390
                  WHEN MQQT-MODEL                                       REA09400
                      MOVE 'MODEL QUEUE' TO WS-TEXT                     REA09410
                  WHEN MQQT-ALIAS                                       REA09420
                      MOVE 'ALIAS QUEUE' TO WS-TEXT                     REA09430
                  WHEN MQQT-REMOTE                                      REA09440
                      MOVE 'REMOTE QUEUE' TO WS-TEXT                    REA09450
                  WHEN OTHER                                            REA09460
                      MOVE '**UNKNOWN**' TO WS-TEXT                     REA09470
              END-EVALUATE                                              REA09480
           END-IF.                                                      REA09490
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA09500
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA09510
                                MQCFIN-VALUE OF MQCFIN                  REA09520
                                WS-LONG-HEXDISP.                        REA09530
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA09540
                   'MQCFIN-VALUE           ='                           REA09550
                   'X''' WS-LONG-HEXDISP   ''''                         REA09560
                   ' ' MQCFIN-VALUE OF MQCFIN                           REA09570
                   ' ' WS-TEXT.                                         REA09580
       DISPLAY-INTEGER-STRUC-END.                                       REA09590
           EXIT.                                                        REA09600
      ******************************************************************REA09610
      * Process integer START/STOP structure.                           REA09620
      ******************************************************************REA09630
       DISPLAY-SSTOP-INTEGER-STRUC SECTION.                             REA09640
      * parameter                                                       REA09650
           MOVE SPACES TO WS-TEXT-TITLE.                                REA09660
           EVALUATE MQCFIN-PARAMETER OF MQCFIN                          REA09670
               WHEN MQIACF-ERROR-IDENTIFIER                             REA09680
                   MOVE 'MQIACF-ERROR-IDENTIFIER' TO WS-TEXT-TITLE      REA09690
               WHEN MQIACF-REASON-QUALIFIER                             REA09700
                   MOVE 'MQIACF-REASON-QUALIFIER' TO WS-TEXT-TITLE      REA09710
               WHEN MQIACF-AUX-ERROR-DATA-INT-1                         REA09720
                   MOVE 'MQIACF-AUX-ERROR-DATA-INT-1' TO WS-TEXT-TITLE  REA09730
               WHEN MQIACF-AUX-ERROR-DATA-INT-2                         REA09740
                   MOVE 'MQIACF-AUX-ERROR-DATA-INT-2' TO WS-TEXT-TITLE  REA09750
               WHEN OTHER                                               REA09760
                   MOVE '**UNKNOWN**' TO WS-TEXT-TITLE                  REA09770
           END-EVALUATE.                                                REA09780
      *                                                                 REA09790
      * value                                                           REA09800
           MOVE SPACES TO WS-TEXT.                                      REA09810
           IF MQCFIN-PARAMETER OF MQCFIN = MQIACF-REASON-QUALIFIER      REA09820
              EVALUATE MQCFIN-VALUE OF MQCFIN                           REA09830
                  WHEN MQRQ-CHANNEL-STOPPED-OK                          REA09840
                      MOVE 'MQRQ-CHANNEL-STOPPED-OK' TO WS-TEXT         REA09850
                  WHEN MQRQ-CHANNEL-STOPPED-ERROR                       REA09860
                      MOVE 'MQRQ-CHANNEL-STOPPED-ERROR' TO WS-TEXT      REA09870
                  WHEN MQRQ-CHANNEL-STOPPED-RETRY                       REA09880
                      MOVE 'MQRQ-CHANNEL-STOPPED-RETRY' TO WS-TEXT      REA09890
                  WHEN MQRQ-CHANNEL-STOPPED-DISABLED                    REA09900
                      MOVE 'MQRQ-CHANNEL-STOPPED-DISABLED' TO WS-TEXT   REA09910
                  WHEN OTHER                                            REA09920
                      MOVE '**UNKNOWN**' TO WS-TEXT                     REA09930
              END-EVALUATE                                              REA09940
           END-IF.                                                      REA09950
      *                                                                 REA09960
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA09970
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA09980
                                MQCFIN-VALUE OF MQCFIN                  REA09990
                                WS-LONG-HEXDISP.                        REA10000
      *                                                                 REA10010
           DISPLAY '    ' WS-TEXT-TITLE ' '                             REA10020
                   'X''' WS-LONG-HEXDISP   ''''                         REA10030
      *            ' ' MQCFIN-VALUE OF MQCFIN                           REA10040
                   ' ' WS-TEXT.                                         REA10050
      *                                                                 REA10060
       DISPLAY-SSTOP-INTEGER-STRUC-ND.                                  REA10070
           EXIT.                                                        REA10080
      ******************************************************************REA10090
      * Process integer-list structure.                                 REA10100
      ******************************************************************REA10110
       DISPLAY-INTEGER-LIST-STRUC SECTION.                              REA10120
           DISPLAY ' '                                                  REA10130
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA10140
                   'MQCFIL structure'.                                  REA10150
      *                                                                 REA10160
           EVALUATE MQCFIL-TYPE OF MQCFIL                               REA10170
               WHEN MQCFT-COMMAND                                       REA10180
                   MOVE 'COMMAND' TO WS-TEXT                            REA10190
               WHEN MQCFT-RESPONSE                                      REA10200
                   MOVE 'RESPONSE' TO WS-TEXT                           REA10210
               WHEN MQCFT-INTEGER                                       REA10220
                   MOVE 'INTEGER' TO WS-TEXT                            REA10230
               WHEN MQCFT-STRING                                        REA10240
                   MOVE 'STRING' TO WS-TEXT                             REA10250
               WHEN MQCFT-INTEGER-LIST                                  REA10260
                   MOVE 'INTEGER LIST' TO WS-TEXT                       REA10270
               WHEN MQCFT-STRING-LIST                                   REA10280
                   MOVE 'STRING-LIST' TO WS-TEXT                        REA10290
               WHEN MQCFT-EVENT                                         REA10300
                   MOVE 'EVENT' TO WS-TEXT                              REA10310
               WHEN OTHER                                               REA10320
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA10330
           END-EVALUATE.                                                REA10340
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA10350
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA10360
                                MQCFIL-TYPE OF MQCFIL                   REA10370
                                WS-LONG-HEXDISP.                        REA10380
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA10390
                   'MQCFIL-TYPE            ='                           REA10400
                   'X''' WS-LONG-HEXDISP   ''''                         REA10410
                   ' ' MQCFIL-TYPE OF MQCFIL                            REA10420
                   ' ' WS-TEXT.                                         REA10430
      *                                                                 REA10440
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA10450
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA10460
                                MQCFIL-STRUCLENGTH OF MQCFIL            REA10470
                                WS-LONG-HEXDISP.                        REA10480
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA10490
                   'MQCFIL-STRUCLENGTH     ='                           REA10500
                   'X''' WS-LONG-HEXDISP   ''''                         REA10510
                   ' ' MQCFIL-STRUCLENGTH OF MQCFIL.                    REA10520
      *                                                                 REA10530
      * parameter                                                       REA10540
           EVALUATE MQCFIL-PARAMETER OF MQCFIL                          REA10550
               WHEN MQIACH-CHANNEL-ERROR-DATA                           REA10560
                   MOVE 'MQIACH-CHANNEL-ERROR-DATA' TO WS-TEXT          REA10570
               WHEN OTHER                                               REA10580
                   MOVE '*NOT CODED*' TO WS-TEXT                        REA10590
           END-EVALUATE.                                                REA10600
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA10610
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA10620
                                MQCFIL-PARAMETER OF MQCFIL              REA10630
                                WS-LONG-HEXDISP.                        REA10640
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA10650
                   'MQCFIL-PARAMETER       ='                           REA10660
                   'X''' WS-LONG-HEXDISP   ''''                         REA10670
                   ' ' MQCFIL-PARAMETER OF MQCFIL                       REA10680
                   ' ' WS-TEXT.                                         REA10690
      *                                                                 REA10700
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA10710
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA10720
                                MQCFIL-COUNT OF MQCFIL                  REA10730
                                WS-LONG-HEXDISP.                        REA10740
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA10750
                   'MQCFIL-COUNT           ='                           REA10760
                   'X''' WS-LONG-HEXDISP   ''''                         REA10770
                   ' ' MQCFIL-COUNT OF MQCFIL.                          REA10780
      *                                                                 REA10790
           PERFORM TEST BEFORE VARYING L FROM 1 BY 1                    REA10800
             UNTIL (L > MQCFIL-COUNT)                                   REA10810
             DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                      REA10820
                   'Value                  =' CFIL-DATA(L)              REA10830
           END-PERFORM.                                                 REA10840
       DISPLAY-INTEGER-LIST-STRUC-END.                                  REA10850
           EXIT.                                                        REA10860
      ******************************************************************REA10870
      * Process string structure.                                       REA10880
      ******************************************************************REA10890
       DISPLAY-STRING-STRUC SECTION.                                    REA10900
           DISPLAY ' '                                                  REA10910
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA10920
                   'MQCFST structure'.                                  REA10930
      *                                                                 REA10940
           EVALUATE MQCFST-TYPE OF MQCFST                               REA10950
               WHEN MQCFT-COMMAND                                       REA10960
                   MOVE 'COMMAND' TO WS-TEXT                            REA10970
               WHEN MQCFT-RESPONSE                                      REA10980
                   MOVE 'RESPONSE' TO WS-TEXT                           REA10990
               WHEN MQCFT-INTEGER                                       REA11000
                   MOVE 'INTEGER' TO WS-TEXT                            REA11010
               WHEN MQCFT-STRING                                        REA11020
                   MOVE 'STRING' TO WS-TEXT                             REA11030
               WHEN MQCFT-INTEGER-LIST                                  REA11040
                   MOVE 'INTEGER LIST' TO WS-TEXT                       REA11050
               WHEN MQCFT-STRING-LIST                                   REA11060
                   MOVE 'STRING-LIST' TO WS-TEXT                        REA11070
               WHEN MQCFT-EVENT                                         REA11080
                   MOVE 'EVENT' TO WS-TEXT                              REA11090
               WHEN OTHER                                               REA11100
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA11110
           END-EVALUATE.                                                REA11120
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA11130
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA11140
                                MQCFST-TYPE OF MQCFST                   REA11150
                                WS-LONG-HEXDISP.                        REA11160
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA11170
                   'MQCFST-TYPE            ='                           REA11180
                   'X''' WS-LONG-HEXDISP   ''''                         REA11190
                   ' ' MQCFST-TYPE OF MQCFST                            REA11200
                   ' ' WS-TEXT.                                         REA11210
      *                                                                 REA11220
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA11230
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA11240
                                MQCFST-STRUCLENGTH OF MQCFST            REA11250
                                WS-LONG-HEXDISP.                        REA11260
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA11270
                   'MQCFST-STRUCLENGTH     ='                           REA11280
                   'X''' WS-LONG-HEXDISP   ''''                         REA11290
                   ' ' MQCFST-STRUCLENGTH OF MQCFST.                    REA11300
      *                                                                 REA11310
      * parameter                                                       REA11320
           EVALUATE MQCFST-PARAMETER OF MQCFST                          REA11330
               WHEN MQCACF-APPL-NAME                                    REA11340
                   MOVE 'MQCACF-APPL-NAME' TO WS-TEXT                   REA11350
               WHEN MQCACF-AUX-ERROR-DATA-STR-1                         REA11360
                   MOVE 'MQCACF-AUX-ERROR-DATA-STR-1' TO WS-TEXT        REA11370
               WHEN MQCACF-AUX-ERROR-DATA-STR-2                         REA11380
                   MOVE 'MQCACF-AUX-ERROR-DATA-STR-2' TO WS-TEXT        REA11390
               WHEN MQCACF-AUX-ERROR-DATA-STR-3                         REA11400
                   MOVE 'MQCACF-AUX-ERROR-DATA-STR-3' TO WS-TEXT        REA11410
               WHEN MQCA-BASE-Q-NAME                                    REA11420
                   MOVE 'MQCA-BASE-Q-NAME' TO WS-TEXT                   REA11430
               WHEN MQCACH-CHANNEL-NAME                                 REA11440
                   MOVE 'MQCACH-CHANNEL-NAME' TO WS-TEXT                REA11450
               WHEN MQCA-PROCESS-NAME                                   REA11460
                   MOVE 'MQCA-PROCESS-NAME' TO WS-TEXT                  REA11470
               WHEN MQCACF-OBJECT-Q-MGR-NAME                            REA11480
                   MOVE 'MQCACF-OBJECT-Q-MGR-NAME' TO WS-TEXT           REA11490
               WHEN MQCA-Q-MGR-NAME                                     REA11500
                   MOVE 'MQCA-Q-MGR-NAME' TO WS-TEXT                    REA11510
               WHEN MQCA-Q-NAME                                         REA11520
                   MOVE 'MQCA-Q-NAME' TO WS-TEXT                        REA11530
               WHEN MQCA-REMOTE-Q-MGR-NAME                              REA11540
                   MOVE 'MQCA-REMOTE-Q-MGR-NAME' TO WS-TEXT             REA11550
               WHEN MQCA-XMIT-Q-NAME                                    REA11560
                   MOVE 'MQCA-XMIT-Q-NAME' TO WS-TEXT                   REA11570
               WHEN MQCACH-XMIT-Q-NAME                                  REA11580
                   MOVE 'MQCACH-XMIT-Q-NAME' TO WS-TEXT                 REA11590
               WHEN MQCACH-CONNECTION-NAME                              REA11600
                   MOVE 'MQCACH-CONNECTION-NAME' TO WS-TEXT             REA11610
               WHEN OTHER                                               REA11620
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA11630
           END-EVALUATE.                                                REA11640
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA11650
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA11660
                                MQCFST-PARAMETER OF MQCFST              REA11670
                                WS-LONG-HEXDISP.                        REA11680
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA11690
                   'MQCFST-PARAMETER       ='                           REA11700
                   'X''' WS-LONG-HEXDISP   ''''                         REA11710
                   ' ' MQCFST-PARAMETER OF MQCFST                       REA11720
                   ' ' WS-TEXT.                                         REA11730
      *                                                                 REA11740
           MOVE SPACES TO WS-TEXT.                                      REA11750
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA11760
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA11770
                                MQCFST-CODEDCHARSETID OF MQCFST         REA11780
                                WS-LONG-HEXDISP.                        REA11790
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA11800
                   'MQCFST-CODEDCHARSETID  ='                           REA11810
                   'X''' WS-LONG-HEXDISP   ''''                         REA11820
                   ' ' MQCFST-CODEDCHARSETID OF MQCFST                  REA11830
                   ' ' WS-TEXT.                                         REA11840
      *                                                                 REA11850
           MOVE SPACES TO WS-TEXT.                                      REA11860
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA11870
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA11880
                                MQCFST-STRINGLENGTH OF MQCFST           REA11890
                                WS-LONG-HEXDISP.                        REA11900
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA11910
                   'MQCFST-STRINGLENGTH    ='                           REA11920
                   'X''' WS-LONG-HEXDISP   ''''                         REA11930
                   ' ' MQCFST-STRINGLENGTH OF MQCFST                    REA11940
                   ' ' WS-TEXT.                                         REA11950
      *                                                                 REA11960
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA11970
                   'String=' CFST-DATA(1:MQCFST-STRINGLENGTH) '='.      REA11980
       DISPLAY-STRING-STRUC-END.                                        REA11990
           EXIT.                                                        REA12000
      ******************************************************************REA12010
      * Process START/STOP string structure.                            REA12020
      ******************************************************************REA12030
       DISPLAY-SSTOP-STRING-STRUC SECTION.                              REA12040
      * parameter                                                       REA12050
           EVALUATE MQCFST-PARAMETER OF MQCFST                          REA12060
               WHEN MQCACF-APPL-NAME                                    REA12070
                   MOVE 'MQCACF-APPL-NAME' TO WS-TEXT                   REA12080
               WHEN MQCACF-AUX-ERROR-DATA-STR-1                         REA12090
                   MOVE 'MQCACF-AUX-ERROR-DATA-STR-1' TO WS-TEXT        REA12100
               WHEN MQCACF-AUX-ERROR-DATA-STR-2                         REA12110
                   MOVE 'MQCACF-AUX-ERROR-DATA-STR-2' TO WS-TEXT        REA12120
               WHEN MQCACF-AUX-ERROR-DATA-STR-3                         REA12130
                   MOVE 'MQCACF-AUX-ERROR-DATA-STR-3' TO WS-TEXT        REA12140
               WHEN MQCA-BASE-Q-NAME                                    REA12150
                   MOVE 'MQCA-BASE-Q-NAME' TO WS-TEXT                   REA12160
               WHEN MQCACH-CHANNEL-NAME                                 REA12170
                   MOVE 'MQCACH-CHANNEL-NAME' TO WS-TEXT                REA12180
               WHEN MQCA-PROCESS-NAME                                   REA12190
                   MOVE 'MQCA-PROCESS-NAME' TO WS-TEXT                  REA12200
               WHEN MQCACF-OBJECT-Q-MGR-NAME                            REA12210
                   MOVE 'MQCACF-OBJECT-Q-MGR-NAME' TO WS-TEXT           REA12220
               WHEN MQCA-Q-MGR-NAME                                     REA12230
                   MOVE 'MQCA-Q-MGR-NAME' TO WS-TEXT                    REA12240
               WHEN MQCA-Q-NAME                                         REA12250
                   MOVE 'MQCA-Q-NAME' TO WS-TEXT                        REA12260
               WHEN MQCA-REMOTE-Q-MGR-NAME                              REA12270
                   MOVE 'MQCA-REMOTE-Q-MGR-NAME' TO WS-TEXT             REA12280
               WHEN MQCA-XMIT-Q-NAME                                    REA12290
                   MOVE 'MQCA-XMIT-Q-NAME' TO WS-TEXT                   REA12300
               WHEN MQCACH-XMIT-Q-NAME                                  REA12310
                   MOVE 'MQCACH-XMIT-Q-NAME' TO WS-TEXT                 REA12320
               WHEN MQCACH-CONNECTION-NAME                              REA12330
                   MOVE 'MQCACH-CONNECTION-NAME' TO WS-TEXT             REA12340
               WHEN OTHER                                               REA12350
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA12360
           END-EVALUATE.                                                REA12370
      *                                                                 REA12380
           DISPLAY  '    ' WS-TEXT                                      REA12390
                   ' =' CFST-DATA(1:MQCFST-STRINGLENGTH) '='.           REA12400
      *                                                                 REA12410
       DISPLAY-SSTOP-STRING-STRUC-END.                                  REA12420
           EXIT.                                                        REA12430
      ******************************************************************REA12440
      * Process string-list structure.                                  REA12450
      ******************************************************************REA12460
       DISPLAY-STRING-LIST-STRUC SECTION.                               REA12470
           DISPLAY ' '                                                  REA12480
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA12490
                   'MQCFSL structure'.                                  REA12500
      *                                                                 REA12510
           EVALUATE MQCFSL-TYPE OF MQCFSL                               REA12520
               WHEN MQCFT-COMMAND                                       REA12530
                   MOVE 'COMMAND' TO WS-TEXT                            REA12540
               WHEN MQCFT-RESPONSE                                      REA12550
                   MOVE 'RESPONSE' TO WS-TEXT                           REA12560
               WHEN MQCFT-INTEGER                                       REA12570
                   MOVE 'INTEGER' TO WS-TEXT                            REA12580
               WHEN MQCFT-STRING                                        REA12590
                   MOVE 'STRING' TO WS-TEXT                             REA12600
               WHEN MQCFT-INTEGER-LIST                                  REA12610
                   MOVE 'INTEGER LIST' TO WS-TEXT                       REA12620
               WHEN MQCFT-STRING-LIST                                   REA12630
                   MOVE 'STRING-LIST' TO WS-TEXT                        REA12640
               WHEN MQCFT-EVENT                                         REA12650
                   MOVE 'EVENT' TO WS-TEXT                              REA12660
               WHEN OTHER                                               REA12670
                   MOVE '**UNKNOWN**' TO WS-TEXT                        REA12680
           END-EVALUATE.                                                REA12690
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA12700
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA12710
                                MQCFSL-TYPE OF MQCFSL                   REA12720
                                WS-LONG-HEXDISP.                        REA12730
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA12740
                   'MQCFSL-TYPE            ='                           REA12750
                   'X''' WS-LONG-HEXDISP   ''''                         REA12760
                   ' ' MQCFSL-TYPE OF MQCFSL                            REA12770
                   ' ' WS-TEXT.                                         REA12780
      *                                                                 REA12790
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA12800
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA12810
                                MQCFSL-STRUCLENGTH OF MQCFSL            REA12820
                                WS-LONG-HEXDISP.                        REA12830
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA12840
                   'MQCFSL-STRUCLENGTH     ='                           REA12850
                   'X''' WS-LONG-HEXDISP   ''''                         REA12860
                   ' ' MQCFSL-STRUCLENGTH OF MQCFSL.                    REA12870
      *                                                                 REA12880
      * parameter                                                       REA12890
           MOVE SPACES TO WS-TEXT.                                      REA12900
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA12910
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA12920
                                MQCFSL-PARAMETER OF MQCFSL              REA12930
                                WS-LONG-HEXDISP.                        REA12940
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA12950
                   'MQCFSL-PARAMETER       ='                           REA12960
                   'X''' WS-LONG-HEXDISP   ''''                         REA12970
                   ' ' MQCFSL-PARAMETER OF MQCFSL                       REA12980
                   ' ' WS-TEXT.                                         REA12990
      *                                                                 REA13000
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA13010
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA13020
                                MQCFSL-CODEDCHARSETID OF MQCFSL         REA13030
                                WS-LONG-HEXDISP.                        REA13040
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA13050
                   'MQCFSL-CODEDCHARSETID  ='                           REA13060
                   'X''' WS-LONG-HEXDISP   ''''                         REA13070
                   ' ' MQCFSL-CODEDCHARSETID OF MQCFSL                  REA13080
                   ' ' WS-TEXT.                                         REA13090
      *                                                                 REA13100
           MOVE SPACES TO WS-TEXT.                                      REA13110
           MOVE 4 TO WS-XTOCHAR-LEN.                                    REA13120
           CALL 'XTOCHAR' USING WS-XTOCHAR-LEN                          REA13130
                                MQCFSL-STRINGLENGTH OF MQCFSL           REA13140
                                WS-LONG-HEXDISP.                        REA13150
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA13160
                   'MQCFSL-STRINGLENGTH    ='                           REA13170
                   'X''' WS-LONG-HEXDISP   ''''                         REA13180
                   ' ' MQCFSL-STRINGLENGTH OF MQCFSL                    REA13190
                   ' ' WS-TEXT.                                         REA13200
      *                                                                 REA13210
           DISPLAY WS-TIME-DISPLAY ' ' WS-BLANK9                        REA13220
                   'Str length = ' MQCFSL-STRINGLENGTH.                 REA13230
           PERFORM TEST BEFORE VARYING L FROM 1 BY 1                    REA13240
             UNTIL (L > MQCFSL-COUNT)                                   REA13250
             COMPUTE K = (L - 1) * MQCFSL-STRINGLENGTH + 1              REA13260
             DISPLAY 'String=' CFSL-DATA(K:MQCFSL-STRINGLENGTH) '='     REA13270
           END-PERFORM.                                                 REA13280
       DISPLAY-STRING-LIST-STRUC-END.                                   REA13290
           EXIT.                                                        REA13300
      *                                                                 REA13310
       ACCEPT-TIME SECTION.                                             REA13320
           ACCEPT WS-TIME FROM TIME.                                    REA13330
           MOVE WS-TIME-HOUR TO WS-TIME-DISPLAY-HOUR.                   REA13340
           MOVE WS-TIME-MIN  TO WS-TIME-DISPLAY-MIN.                    REA13350
           MOVE WS-TIME-SEC  TO WS-TIME-DISPLAY-SEC.                    REA13360
           MOVE WS-TIME-HUND TO WS-TIME-DISPLAY-HUND.                   REA13370
       ACCEPT-TIME-END.                                                 REA13380
           EXIT.                                                        REA13390
      *                                                                 REA13400
      * --------------------------------------------------------------- REA13410
      *                  End of program                                 REA13420
      * --------------------------------------------------------------- REA13430
